Draft Mirror: Difference between revisions

From FreeCAD Documentation
(Undo revision 903027 by Roy 043 (talk))
Tag: Undo
No edit summary
Line 66: Line 66:
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the command.
* Press {{KEY|Esc}} or the {{Button|Close}} button to abort the command.


== Notes ==
==Notes==


* Mirrored copies of [[Draft_Line|Draft Lines]], [[Draft_Wire|Draft Wires]], [[Draft_Arc|Draft Arcs]] and [[Draft_Circle|Draft Circles]] can be turned into independent editable Draft objects by using [[Draft_Downgrade|Draft Downgrade]] and then [[Draft_Upgrade|Draft Upgrade]].
* Mirrored copies of [[Draft_Line|Draft Lines]], [[Draft_Wire|Draft Wires]], [[Draft_Arc|Draft Arcs]] and [[Draft_Circle|Draft Circles]] can be turned into independent editable Draft objects by using [[Draft_Downgrade|Draft Downgrade]] and then [[Draft_Upgrade|Draft Upgrade]].
* The [[Part_SimpleCopy|Part SimpleCopy]] command can be used to create a copy of a mirrored object that is not connected to its source object.
* The [[Part_SimpleCopy|Part SimpleCopy]] command can be used to create a copy of a mirrored object that is not connected to its source object.


== Preferences ==
==Preferences==


See also: [[Preferences_Editor|Preferences Editor]] and [[Draft_Preferences|Draft Preferences]].
See also: [[Preferences_Editor|Preferences Editor]] and [[Draft_Preferences|Draft Preferences]].
Line 83: Line 83:
A [[Part_Mirror|Part Mirror]] object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:
A [[Part_Mirror|Part Mirror]] object is derived from a [[Part_Feature|Part Feature]] object and inherits all its properties. It also has the following additional properties:


=== Data ===
===Data===


{{TitleProperty|Base}}
{{TitleProperty|Base}}
Line 95: Line 95:
* {{PropertyData|Normal|Vector}}: specifies the normal direction of the mirror plane.
* {{PropertyData|Normal|Vector}}: specifies the normal direction of the mirror plane.


== Scripting == <!--T:23-->
==Scripting== <!--T:23-->


<!--T:7-->
<!--T:7-->

Revision as of 16:21, 13 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Mirror

Menu location
Modification → Mirror
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft Scale, Draft Clone

Description

The Draft Mirror tool produces a mirrored copy of a selected object, using the Part Mirror operation. The copy, just like a Draft Clone, is linked to the original object. This means that if the original object changes its shape and properties, the mirrored shape changes as well.

The Mirror tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Mirrored object created using a mirroring line

Usage

See also: Draft Snap and Draft Constrain.

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Draft Mirror button.
    • Select the Modification → Mirror option from the menu.
    • Use the keyboard shortcut: M then I.
  3. If you have not yet selected an object: select an object in the 3D view.
  4. The Mirror task panel opens. See Options for more information.
  5. Pick the first point of the mirror plane in the 3D view, or type coordinates and press the Enter point button.
  6. Pick the second point of the mirror plane in the 3D view, or type coordinates and press the Enter point button.
  7. The mirror plane is defined by the selected points and the normal of the Draft working plane.

Options

The single character keyboard shortcuts mentioned here can be changed. See Draft Preferences.

  • To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, the coordinates of the second point are relative to the first point, else they are relative to the coordinate system origin.
  • Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
  • The Continue checkbox has no purpose for this command.
  • The Modify subelements checkbox has no purpose for this command.
  • Press Esc or the Close button to abort the command.

Notes

Preferences

See also: Preferences Editor and Draft Preferences.

  • To change the number of decimals used for the input of coordinates: Edit → Preferences... → General → Units → Units settings → Number of decimals.

Properties

See also: Property editor.

A Part Mirror object is derived from a Part Feature object and inherits all its properties. It also has the following additional properties:

Data

Base

  • DataSource (Link): specifies the object that is mirrored.

Plane

  • DataBase (Vector): specifies the base point of the mirror plane.
  • DataNormal (Vector): specifies the normal direction of the mirror plane.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To mirror objects use the mirror method of the Draft module.

mirrored_list = mirror(objlist, p1, p2)
  • objlist contains the objects to be mirrored. It is either a single object or a list of objects.
  • p1 is the first point of the mirror plane.
  • p2 is the second point of the mirror plane.
  • If the Draft working plane is available the alignment of the mirror plane is determined by its normal, else the view direction of the camera in the active 3D view is used. If the graphical interface is not available the Z axis is used.
  • mirrored_list is returned with the new Part::Mirroring objects. It is either a single object or a list of objects, depending on objlist.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

place = App.Placement(FreeCAD.Vector(1000, 0, 0), App.Rotation())
polygon1 = Draft.make_polygon(3, 750)
polygon2 = Draft.make_polygon(5, 750, placement=place)

p1 = App.Vector(2000, -1000, 0)
p2 = App.Vector(2000, 1000, 0)

line1 = Draft.make_line(p1, p2)
mirrored1 = Draft.mirror(polygon1, p1, p2)

Line2 = Draft.make_line(-p1, -p2)
mirrored2 = Draft.mirror([polygon1, polygon2], -p1, -p2)

doc.recompute()